#!/usr/bin/perl -w

my $dir = '.';
opendir(DIR, $dir) or die $!;
while (my $file = readdir(DIR)) {
  next if ($file !~ m/^.*\.xul$/);
  next if ($file =~ m/^window_/);
  open(FILE, "<$file");
  my %ak = ();
  my $first = 1;
  while(<FILE>)  {
    my($line) = $_;
    chomp($line);
    if($line =~ m/label\s*="([^"]*)".*accesskey\s*="([^"]*)"/) {
      my $x = uc($2);
      if(defined $ak{$x}) {
        print "========= $file ==========\n" if($first == 1);
        $first = 0;
        print "duplicate: $x : $1 + $ak{$x}\n";
      } else {
        $ak{$x} = $1;
      }
    }
  }
  close(FILE);
}
closedir(DIR);
