/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'FSMount';
var subfield = 'fsmounts';
var singular = 'fs mount';
var plural = 'fs mounts';
var editfile = 'editfsmount.xul';

function createTreeItem(one, i) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['order'] = i;
  item['device'] = one.device;
  item['mountpoint'] = one.mountpoint;
  item['filesystem'] = one.filesystem;
  item['mountoptions'] = one.mountoptions;
  item['dump'] = one.dump;
  item['fsck'] = one.fsck;
  item['rdma'] = one.rdma;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  return item;
}

