/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function terminateInstance() {
  var args = new Object();
  args['question'] = "Are you sure you want to terminate this node?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    var nodes = [current.get('uniqueKey')];
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmcloud', 'terminate', [nodes], function(code, data) {
        if(code == 0) {
          if(!data[0]) {
            dock.displayInfo("Unable to terminate");
          }
        } else {
          dock.jsonCallError(this, code, data);
        }
      }, current);
  }
  dock.dialogs.showDialog(d);
}

function consolelog() {
  var args = new Object();
  args['nodes'] = [current.get('uniqueKey')];
  args['cluster'] = current.cluster;
  var d = new dock.cvDialog("consolelog.xul", args);
  dock.dialogs.showDialog(d);
}
