/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var currentlist;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use; // FUTURE: Only one partition

  println("Refresh cluster racksetup" + ' - ' + document.documentURI);

  var list = current.find('Rack');
  
  var racks = document.getElementById('racks');
  while(racks.firstChild) racks.removeChild(racks.firstChild);
  
  for(var i = 0; i < list.length; i++) {
    var vbox = document.createElement("vbox");
    if((list.length + i) % 2 == 0) {
      vbox.setAttribute('class', 'datastripodd');
    } else {
      vbox.setAttribute('class', 'datastripeven');
    }
    var hbox = document.createElement("hbox");
    hbox.setAttribute('align', 'center');
    var lbox = document.createElement("hbox");
    lbox.setAttribute('pack', 'end');
    lbox.setAttribute('width', '150px');    
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Name:');
    label.setAttribute('class', 'staticdataheader');
    lbox.appendChild(label);
    hbox.appendChild(lbox);
    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', 'rack_' + i + 'name');
    textbox.setAttribute('type', 'timed');
    textbox.setAttribute('width', '190px');
    hbox.appendChild(textbox);
    vbox.appendChild(hbox);
    racks.appendChild(vbox);

    var hbox = document.createElement("hbox");
    hbox.setAttribute('align', 'center');
    var lbox = document.createElement("hbox");
    lbox.setAttribute('pack', 'end');
    lbox.setAttribute('width', '150px');    
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Room:');
    label.setAttribute('class', 'staticdataheader');
    lbox.appendChild(label);
    hbox.appendChild(lbox);
    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', 'rack_' + i + 'room');
    textbox.setAttribute('type', 'timed');
    textbox.setAttribute('width', '190px');
    hbox.appendChild(textbox);
    vbox.appendChild(hbox);
    racks.appendChild(vbox);

    var hbox = document.createElement("hbox");
    hbox.setAttribute('align', 'center');
    var lbox = document.createElement("hbox");
    lbox.setAttribute('pack', 'end');
    lbox.setAttribute('width', '150px');    
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Postition:');
    label.setAttribute('class', 'staticdataheader');
    lbox.appendChild(label);
    hbox.appendChild(lbox);
    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', 'rack_' + i + 'xCoordinate');
    textbox.setAttribute('type', 'timed');
    textbox.setAttribute('width', '95px');
    hbox.appendChild(textbox);
    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', 'rack_' + i + 'yCoordinate');
    textbox.setAttribute('type', 'timed');
    textbox.setAttribute('width', '94px');
    hbox.appendChild(textbox);
    vbox.appendChild(hbox);
    racks.appendChild(vbox);

    var hbox = document.createElement("hbox");
    hbox.setAttribute('align', 'center');
    var lbox = document.createElement("hbox");
    lbox.setAttribute('pack', 'end');
    lbox.setAttribute('width', '150px');    
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Height:');
    label.setAttribute('class', 'staticdataheader');
    lbox.appendChild(label);
    hbox.appendChild(lbox);
    var menulist = document.createElement("menulist");
    menulist.setAttribute('id', 'rack_' + i + 'height');
    menulist.setAttribute('width', '95px');
    var menupopup = document.createElement("menupopup");
    menulist.appendChild(menupopup);
    hbox.appendChild(menulist);
    var check = document.createElement("checkimage");
    check.setAttribute('id', 'rack_' + i + 'inverted');
    check.setAttribute('label', 'Bottom of rack is position 1');    
    hbox.appendChild(check);
    vbox.appendChild(hbox);
    
    racks.appendChild(vbox);
  }
  
  for(var i = 0; i < list.length; i++) {
    text('rack_' + i, '^.+', 'name', true);
    text('rack_' + i, '^.+', 'room');
    text('rack_' + i, '^[0-9]+$', 'xCoordinate');
    text('rack_' + i, '^[0-9]+$', 'yCoordinate');
//     number('rack_' + i, 8, dock.MAXRACKHEIGHT, 'U', 0, 'height');
//     check('rack_' + i, false, 'inverted');
    autorefresh('rack_' + i, 'name');
  }
}
