/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var current;
var fieldname = false;
var subtype = 'Device';
var currentnodes;
var myDialog;
var dock;

var singular = 'device';
var plural = 'devices';
var belongs = '0';
var noloop = 'true';
var extraName = "''";
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['category', 'category', true],
            ['installmode', 'installMode', false],
            ['rack', 'rack.rack', true],
            ['position', 'rack.position', false],
            ['running job', '@JOB@', false]];

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.cluster;
  subtype = myDialog.arguments.subtype;
  if(myDialog.arguments.hasOwnProperty('selection')) {
    currentnodes = myDialog.arguments.selection;
  } else {
    currentnodes = new Array();
  }

  current.updateNodeJobCache();
  
  refresh();
}

function refresh() {
  deviceselect();
}

function ok() {
  apply();
  cancel();
}

function apply() {
  myDialog.apply(currentnodes);
}

function cancel() {
  close();
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("wait");
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("auto");
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}
