/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

/* Drag-Drop functionality for the profiles
 * allows new profiles to be dragged onto trees
 */
var listObserver =   {
  onDragStart: function (evt,transferData,action) {
    var txt = evt.target.getAttribute("label");
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("text/unicode",txt);
  }
};
var boardObserver = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  onDragOver: function (evt,flavour,session){},
  onDrop: function (evt,dropdata,session) {
    if (dropdata.data!="") {
      var profile = dropdata.data;
      var cmdest = evt.target.id.split(":")[1];
      addProfileToCM(cmdest, profile);
    }
  }
};

