/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var newEdit;
var myDialog;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  if(myDialog.arguments.cluster) {
    current = myDialog.arguments.cluster;
    document.getElementById("name").value = current.name;
    document.getElementById("host").value = current.host + ':' + current.port;
    document.getElementById("username").value = current.username;
    document.getElementById("password").value = current.password;
    document.getElementById("autoconnect").checked = current.autoconnect;
    document.getElementById("followRedirect").checked = current.followRedirect;
    newEdit = false;
  } else {
    newEdit = true;
    setDialogTitle("Add New Cluster");
    document.getElementById("followRedirect").checked = true;
  }

  document.getElementById("host").focus();
}

function ok() {
  current = myDialog.arguments.cluster; // should be no need for this
  var host = document.getElementById("host").value;
  if(blank(host)) {
    dock.displayError("Hostname cannot be empty");
    return;
  }
  var host = document.getElementById("host").value;
  var user = document.getElementById("username").value;
  var pass = document.getElementById("password").value;
  var auto = document.getElementById("autoconnect").checked
  var fr = document.getElementById("followRedirect").checked
  if(newEdit) {
    var current = new dock.cvCluster();
    current.name = '';
//     this.treeClosed = ["SwitchFolder", "NetworkFolder", "PowerDistributionUnitFolder", "SoftwareImageFolder", "CategoryFolder", "HeadNodeFolder", "ChassisFolder", "NodeFolder", "GpuUnitFolder", "OtherDeviceFolder", "NodeGroupFolder"];
    dock.appendCluster(current);
  }
  current.setUrl(host);
  current.username = user;
  current.password = pass;
  current.autoconnect = auto;
  current.followRedirect = fr;
  myDialog.onOk();
  close();
}

function cancel() {
  close();
}
