/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var role;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  newEdit = false;
  object = myDialog.arguments.object;
  role = myDialog.arguments.role;
  current = role.osdassociations[myDialog.arguments.osdassociations];
  if(isObject(current)) {
    current = new dock.cvObject(object.cluster, current);
    old = current.old(false, true);
    refresh();
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  
  text('name', '');
  text('dataPath', '');
  text('journalPath', '');
  text('journalSize', '^[0-9]+$');

  setfocus('name');
}

function ok() {
  if(!window.closed) {
    role.modified = true;
    object.set('modified', true);
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
