/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var messages;

function onLoad() {
  dock = getDock();
  println("Error initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  messages = [myDialog.arguments];
  document.getElementById('message').value = myDialog.arguments;
  document.getElementById('ok').focus();

  if(myDialog.timeout > 0) {
    window.setTimeout('close()', myDialog.timeout * 1000);
  }
}

function updateMessage(msg) {
  if(typeof(messages) == 'undefined') {
    messages = new Array();
  }
  var idx = messages.find(msg);
  if(idx > 0) {
    messages.splice(idx, 1); // put on top
  } else if(idx == 0) {
    return;
  }
  messages.unshift(msg);
  document.getElementById('message').value = '- ' + messages.join('\n- ');
}
