/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock
var myDialog;

function onLoad() {
  dock = getDock();
  println("Detached event viewer: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  window.frames[0].refresh(myDialog.arguments.viewer);
  document.getElementById('filtername').setAttribute('value', myDialog.arguments.viewer.filter.name);

}

function onClose() {
  myDialog.arguments.viewer.frame = 0;
  myDialog.arguments.viewer.close();
}

function reatachEvent() {
  close();
  myDialog.arguments.viewer.reatach();
  dock.openViewers();
}

function clearEvent(event) {
  myDialog.arguments.viewer.clearEvents(event.shiftKey);
}

function filterEvent() {
  myDialog.arguments.viewer.showFilter();
}
