/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var cmguiVersion = "1.0.0";
var brightVersion = "7.3";

var supportURI = 'http://www.brightcomputing.com/burst/cmgui-request-support-form.php';

var MAX_LOCAL_KEY = 4294967296;
var MINSWITCHPORTS = -1;
var MAXSWITCHPORTS = 999;
var BLANKSWITCHPORTS = -1;
var MAXDEVICEHEIGHT = 48;
var MINRACKHEIGHT = 8;
var MAXRACKHEIGHT = 64;
var MINRACKWIDTH = 11;
var MAXRACKWIDTH = 31;

var GRAPH_GROUP_WHISKER = 0;
var GRAPH_GROUP_HEATMAP = 1;
var GRAPH_GROUP_SUM = 2;
var GRAPH_GROUP_MIN = 3;
var GRAPH_GROUP_MAX = 4;
var GRAPH_GROUP_AVG = 5;
var GRAPH_GROUP_PIE = 6;
var GRAPH_GROUP_MIN_MED_MAX = 7;

var MAX_FAILED_EVENTS = 8;
/* Constants
 *  For certificate database
 */
var nsIFilePicker  = Components.interfaces.nsIFilePicker;
var nsFilePicker  = "@mozilla.org/filepicker;1";

/* Constants
 *  For application and user information
 */
var AppInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
var cmdLine = Components.classes["@mozilla.org/toolkit/command-line;1"].createInstance(Components.interfaces.nsICommandLine);
var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"] .getService(Components.interfaces.nsIClipboardHelper);
var mainthread = Components.classes["@mozilla.org/thread-manager;1"].getService().mainThread;  
var environment = Components.classes["@mozilla.org/process/environment;1"].getService(Components.interfaces.nsIEnvironment);
var windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

var REGEX_HOSTNAME = '(?!^[0-9]+$)^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]*[a-zA-Z0-9])$';
var REGEX_IF_BASE = '(BOOTIF|\\S+[0-9]+|\\S+(p[0-9]{1,4})(s[0-9]{1,4})(f[0-9]{1,4})?)';
var REGEX_IF_PHYSICAL = '^' + REGEX_IF_BASE + '$';
var REGEX_IF_VLAN = '^' + REGEX_IF_BASE + '\.[0-9]{1,4}$';
var REGEX_IF_ALIAS = '^' + REGEX_IF_BASE + '(\\.[0-9]{1,4})?:\\w+$';
var REGEX_IF_ANY = '^' + REGEX_IF_BASE + '((\\.[0-9]{1,4})?:\\w+)?$';

// NOT THE SAME ALS c VERSION
// \.   --->   \\.
var REGEX_IPv4_PARTIAL = '^(25[0-5]|2[0-4][0-9]|[0-1]?[0-9]?[0-9])$';
var REGEX_IPv4 = '^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})$';
var REGEX_IPv6 = '@FUNCTION@isIPv6'

var REGEX_COPriority = '@FUNCTION@checkConfOverlayPriority'

var FILL_COUNT = 250;
var FILL_TIMEOUT = 50;

var RACK_FILL_COUNT = 10;

var MAX_PARALLEL_SHELL_UDPATE = 100;

var CLONE_SELECT_ALL = false;
var CLONE_LOAD = 0;
var CLONE_SYNC_ONE = 1;
var CLONE_SYNC_N = 2;
var CLONE_CREATE = 3;

var SUBTREE = true;
// var SUBTREE = false;
var SUBTREE_IN_THREAD = true;

// var GUESSIP = false;
var GUESSIP = true;

var openAfterCreate = false; // fix #2031
// var openAfterCreate = true;

var SCALEMPDEMO = false;
// var SCALEMPDEMO = true;
var DEMO = false;
// var DEMO = true;
var CLOUDDEMO = false;
// var CLOUDDEMO = true;

var JOBGROUPDEMO = false;
// var JOBGROUPDEMO = true;

//var IEELDEMO = false;
var IEELDEMO = true;

var PLUS_LEFT = 1;
//var PLUS_LEFT = 0;

var waitCount = 0;

/* paths for storing known clusters and certificates */
var BASE_PATH;
var CERT_PATH;

var workerpool;
var clusterlist;
var currentObject = 0;
var currentId = 0;
var rackBlinkKey;
var generalSettings;
var customMetricBounds = new cvCustomMetricBounds();
var recentCloneFiles = 0;
var bookmarks;

var shellTracker;

var dialogs = 1;

var oldfocus;

var MONCONF_KEY_OFFSET = 81604378624; //(19 << 32);
var ALL_POWERDISTRIBUTIONUNITS = (MONCONF_KEY_OFFSET + 1);
var ALL_ETHERNETSWITCHES = (MONCONF_KEY_OFFSET + 2);
var ALL_MYRINETSWITCHES = (MONCONF_KEY_OFFSET + 3);
var ALL_IBSWITCHES = (MONCONF_KEY_OFFSET + 4);
var ALL_MASTERNODES = (MONCONF_KEY_OFFSET + 5);
var ALL_RACKSENSORS = (MONCONF_KEY_OFFSET + 6);
var ALL_GENERICS = (MONCONF_KEY_OFFSET + 7);
var ALL_CHASSIS = (MONCONF_KEY_OFFSET + 8);
var ALL_GPUUNITS = (MONCONF_KEY_OFFSET + 9);
var ALL_MICNODES = (MONCONF_KEY_OFFSET + 10);

var PRE_RUNNING = 0;
var PRE_QUEUED = 1;
var PRE_WAIT_FOR_SEND = 2;
var PRE_SOAP_ERROR = 3;
var PRE_NODE_DOWN = 4;
var PRE_NO_RCM = 5;
var PRE_NO_SUCH_DEVICE = 6;
var PRE_NO_SUCH_NODE = 7;
var PRE_UNKNOWN = 8;
var PRE_KILLED = 9;
var PRE_STOPPED = 10;
var PRE_FINISHED = 11;
var PRE_FAILED_TO_STOP = 12;
var PRE_STILL_RUNNING = 13;
var PRE_BAD_USER = 14;
var PRE_FAILED_TO_START = 15;
var PRE_NOT_STARTED_YET = 16;

var SYNCMODE_FULL = 0
var SYNCMODE_SYNC = 1
var SYNCMODE_UPDATE = 2
var SYNCMODE_GRAB = 3
var SYNCMODE_GRABNEW = 4

var PROVISIONINGPROCESSORJOBSTATUS_NOT_STARTED = 0
var PROVISIONINGPROCESSORJOBSTATUS_STARTED = 1
var PROVISIONINGPROCESSORJOBSTATUS_COMPLETED = 2
var PROVISIONINGPROCESSORJOBSTATUS_FAILED = 3
var PROVISIONINGPROCESSORJOBSTATUS_FAILED_FATAL = 4

var LOAD_FLAGS_CHARSET_CHANGE = 1024;
var ENCODING = null; // LOAD_FLAGS_CHARSET_CHANGE;


function matchCluster(host, port) {
  if(isNumeric(host)) {
    var nhost = parseInt(host);
    for(var j = 0; j < clusterlist.length;  j++) {
      if(nhost == clusterlist[j].key) {
        return clusterlist[j];
      }
    }
  } else {
    port = isundefined(port, 0);
    for(var j = 0; j < clusterlist.length;  j++) {
      if((host == clusterlist[j].host) && ((port == clusterlist[j].port) || (port == 0) )) {
        return clusterlist[j];
      }
    }
  }
  println("Cluster not found: " + host + ":" + port);
  return false;
}

function findObject(globalid) {
  var url = parseUrl(globalid);
  if(url.length >= 3) {
    var cluster = matchCluster(url[1], url[2]);
    if(isObject(cluster)) {
      if(url.length >= 5) {
        var work = cluster.find(url[4]);
        for(var i = 5; i < url.length; i = i + 2) {
          work = work.subObjectFromKey(url[i], url[i + 1]);
          if(!work) {
            println('Unable to find find: ' + globalid);
            return 0;
          }
        }
        return work;
      }
      return cluster;
    }
  }
  return 0;
}

function allKeys(cluster, name) {
  var keys = cluster.find(name);
  for(var i = 0; i < keys.length; i++) {
    keys[i] = keys[i].object.uniqueKey;
  }
  return keys;
}

function connectedClusters() {
  var list = new Array()
  for(var i = 0; i < clusterlist.length; i++) {
    if(clusterlist[i].connected) {
      list.push(clusterlist[i]);
    }
  }
  return list;
}

function connectedClustersCount() {
  var n = 0;
  for(var i = 0; i < clusterlist.length; i++) {
    if(clusterlist[i].connected) {
      n++;
    }
  }
  return n;
}

function getCluster(key) {
  for(var i = 0; i < clusterlist.length; i++) {
    if(clusterlist[i].key == key) return clusterlist[i];
  }
  return false;
}

function appendCluster(cluster) {
  var changed = false;
  if(cluster.key <= 0) {
    var key = 0;
    for(var i = 0; i < clusterlist.length; i++) {
      if(clusterlist[i].key > key) key = clusterlist[i].key;
    }
    cluster.key = key + 1;
    changed = true;
  }
  clusterlist.push(cluster);
  return changed;
}

function loadClusters() {
  var changed = false;
  clusterlist = new Array();
  var file = BASE_PATH + "clusters.dat";
  var data = readListFromFile(file);
  
  if(isArray(data) && (data.length > 0)) {
    while(data.length > 0) {
      var one = new cvCluster();
      if(!one.load(data)) {
        print(data);
      }
      changed = appendCluster(one) || changed;
    }
  } else {
    if(fileExists('/etc/cm-release')) {
      var one = new cvCluster();
      one.url = 'https://master:8081';
      one.setUrl(one.url);
      one.username = 'root';
      appendCluster(one);
      changed = true;
    }
  }
  if(changed) saveClusters();
}

function saveClusters() {
  var file = BASE_PATH + "clusters.dat";
  var data = "";
  for(var i = 0; i < clusterlist.length; i++) {
    data += clusterlist[i].save();
  }
  savefile(file, data);
}

function removeCluster(cluster) {
  var index = clusterlist.find(cluster);
  if(index >= 0) {
    clusterlist.splice(index, 1);
    saveClusters();
    delete ackedEvents[cluster.key];
    saveAckedEvents();
  }
}

/* Add one cluster if not already existing */
function addCluster(cluster, certificate, password, store) {
  var protocol = cluster[0];
  var port = cluster[2];
  var host = cluster[1];
  store = isundefined(store, false);

  if(matchCluster(host, port)) {
    alert("Already connected to this cluster!");
  } else {
    var newCluster = new cvCluster();
    if(newCluster.connect(protocol, host, port, certificate, password, store)) {
      newCluster.createTree();
      appendCluster(newCluster);
      return newCluster;
    } else {
      dock.displayError("Error while connecting to cluser,\nMake sure the cmdaemon is started\nand can be reached.");
    }
  }
  return 0;
}

function createClusterItem(name) {
  var item = document.createElement("menuitem");
  item.setAttribute("label", name);
  item.setAttribute("onclick",'selectDefaultCluster("' + name + '");');
  return item;
}

function setDefaults() {
  var slash = getDirectorySeparator();
  BASE_PATH = getHomeDirectory() + slash;
  BASE_PATH += ".cm" + slash + "cmgui" + slash;
  CERT_PATH = BASE_PATH;
}

function globalinit() {
  clusterlist = new Array();
  rackBlinkKey = new Array();
  generalSettings = new cvSettings();
  bookmarks = new Array();

  shellTracker = new Object();
  shellTracker[0] = new Array();

  dialogs = new cvDialogs();
  dialogs.init();  
  
  workerpool = new cvWorkerPool('chrome://cmgui/content/jsonworker.js');
}

function initSSL() {
}

function cleanupSSL() {
}

function checkLibVersion() {
  return true;
}

function onfocus(event) {
  if(!!oldfocus) {
    if(oldfocus != event.target) {
      if(!!oldfocus.document) oldfocus.document.getElementById("dialogheader").setAttribute("class", "dialogheaderdisabled");
      event.target.document.getElementById("dialogheader").setAttribute("class", "dialogheader");
    }
  }
  oldfocus = event.target;
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
//     println('window ' + window.frames.length);
    for(var i = 0; i < window.frames.length; i++) {
//       println('  window ' + window.frames[i].document.title);
      window.frames[i].window.setCursor("wait");
      if(typeof(window.frames[i].waitIcon) == 'function') {
        window.frames[i].waitIcon();
      }
      var subwindow = window.frames[i].window;
//       println('subwindow ' + subwindow.frames.length);
      for(var j = 0; j < subwindow.frames.length; j++) {
//         println('  subwindow ' + subwindow.frames[j].document.title);
        subwindow.frames[j].window.setCursor("wait");
        if(typeof(subwindow.frames[j].waitIcon) == 'function') {
          subwindow.frames[j].waitIcon();
        }
      }
    }
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) {
      window.frames[i].window.setCursor("auto");
      if(typeof(window.frames[i].unwaitIcon) == 'function') {
        window.frames[i].unwaitIcon();
      }
      var subwindow = window.frames[i].window;
      for(var j = 0; j < subwindow.frames.length; j++) {
        subwindow.frames[j].window.setCursor("auto");
        if(typeof(subwindow.frames[j].unwaitIcon) == 'function') {
          subwindow.frames[j].unwaitIcon();
        }
      }
    }
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}

function getAlreadyArrivedShellTracker(tracker) {
  var list = new Array();
  var i = 0;
  while(i < shellTracker[0].length) {
    if(shellTracker[0][i][3] == tracker) {
      var one = shellTracker[0].splice(i, 1);
      list.push(one[0]);
    } else {
      i++;
    }
  }
  return list;
}

function removeOldPexec() {
  var tmpdir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  tmpdir.initWithPath(createCacheDirectory());
  var pexectmpfile = new RegExp('cmguipexec(\-\\d+)?.out$');

  var oEntries = tmpdir.directoryEntries;
  while(oEntries.hasMoreElements()) {
    var file = oEntries.getNext();
    file.QueryInterface(Components.interfaces.nsIFile);
    if(file.path.match(pexectmpfile)) {
      println('Remove old pexec tmp file: ' + file.path);
      file.remove(false);
    }
  }

  var tmpdir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  tmpdir.initWithPath(createCacheDirectory());
  var pexectmpfile = new RegExp('synclog(\-\\d+)?.out$');

  var oEntries = tmpdir.directoryEntries;
  while(oEntries.hasMoreElements()) {
    var file = oEntries.getNext();
    file.QueryInterface(Components.interfaces.nsIFile);
    if(file.path.match(pexectmpfile)) {
      println('Remove old synclog tmp file: ' + file.path);
      file.remove(false);
    }
  }
}

function hasClone(basetype) {
  if(basetype == 'User') return false;
  if(basetype == 'Group') return false;
  if(basetype == 'JobQueue') return false;
  if(basetype == 'Metric') return false;
  if(basetype == 'HealthCheck') return false;
  if(basetype == 'ThreshAction') return false;
  if(basetype == 'MonConf') return false;
  if(basetype == 'MonMetricConf') return false;
  if(basetype == 'MonHealthConf') return false;
  if(basetype == 'ConsolidatorConf') return false;
  if(basetype == 'Threshold') return false;
  return true;
}

function jsonCallError(worker, code, data) {
  var cluster = worker.current;
  if(isArray(cluster)) cluster = cluster[0];
  while(cluster) {
    if(typeof(cluster.isCluster) == 'boolean') {
      if(cluster.isCluster) {
        break;
      } else {
        cluster = cluster.cluster;
      }
    } else if(typeof(cluster.cluster) == 'undefined') {
      cluster = null;
    } else {
      cluster = cluster.cluster;
    }
  }
  
  var hide = cluster && (cluster.stopping || !cluster.connected || cluster.forcedDisconnect);
  var msg = 'JSON call ' + worker.rpc + ' returned code: ' + code + '\n';
  if(data.hasOwnProperty('errormessage')) msg += data.errormessage + "\n";
  if(cluster) msg += "Cluster: " + cluster.name;
  else msg += "Cluster not set";
  
  switch(code) {
    case(-1):
    case(-2):
      if(cluster) {
        hide = !cluster.callFailed();
      }
      break;
    case(650):
      if(cluster) {
        hide = cluster.connectionLost();
        msg = "Lost connection to cluster: " + cluster.name;
      } else {
        msg = "Lost connection to the cluster";
        printall(worker);
        printall(worker.current);
      }
      break;
    default:
  }
  
  if(cluster && hide) {
    println("Error: " + msg);
  } else {
    dock.displayError(msg, window, true, 0, true);
  }
}
