/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  var myDialog = dock.dialogs.list[index];
  var current = myDialog.arguments.cluster;
  var initialize = myDialog.arguments.initialize;

  if (initialize) {
    initialize({
      'update' : function (decommissionstatus) {
        tree = document.getElementById('tree');
        data = new Array();
        for(var i = 0; i < decommissionstatus['nodes'].length; i++) {
          var item = new Object();
          item['node'] = decommissionstatus['nodes'][i];
          // item['intention'] = decommissionstatus['intention'][i];
          item['currentstatus'] = decommissionstatus['status'][i];
          data.push(item);
        }
        loadTable();
        showThrobber(false);
      },
      'error' : function () {
        close();
      }
    });
  }
  setDialogTitle('Decommission status');
  showThrobber(true);
}

function showThrobber(value) {
  document.querySelector('#list').style.display = value ? 'none' : '';
  document.querySelector('#throbber').style.display = value ? '' : 'none';
}
