/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopAccumuloMasterRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  text('masterPortClient','^[0-9]+$');
  text('masterRecoveryDelay','^[0-9]+$');
  text('masterRecoveryMaxAge','^[0-9]+$');
  text('masterRecoveryTimeMax','^[0-9]+$');
  text('masterServerThreadcheckTime','^[0-9]+$');
  text('masterServerThreadsMinimum','^[0-9]+$');
  text('gcPortClient','^[0-9]+$');
  text('gcCycleDelay','^[0-9]+$');
  text('gcCycleStart','^[0-9]+$');
  text('gcThreadsDelete','^[0-9]+$');
  text('monitorPortClient','^[0-9]+$');
  text('monitorPortLog4j','^[0-9]+$');
  text('tracePortClient','^[0-9]+$');
  check('gcFileArchive');
  check('gcTrashIgnore');
  text_float('gcTracePercent');
}

