/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopHBaseServerRole'

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  // text('modified', '^[0-9]+$');  
  text('masterPort', '^[0-9]+$');
  text('masterInfoPort', '^[0-9]+$');
  text('tmpDir', '');
  text('dataDir', '');
  text('localDir', '');
  text('balancerPeriod', '');
  text('hregionMaxFilesize', '^[0-9]+$');
  text('hbaseHeapSize', '^[0-9]+$');
  text('regionserverHandlerCount', '^[0-9]+$');
  check('failFastExpiredActiveMaster');

  setfocus('masterPort');

}

