/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopNameNodeRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  text('fedMountPoint');
  stringlist('dataDirectories', 'NameNode metadata directories:');
  check('restoreDir');
  text('port', '^[0-9]+$');
  text('portHTTP', '^[0-9]+$');
  text('portHTTPS', '^[0-9]+$');
  text('handlerCount', '^[0-9]+$');
  text('serviceHandlerCount', '^[0-9]+$');
  text('trashInterval', '^[0-9]+$');
  text('checkpointTxns', '^[0-9]+$');
  text('checkpointPeriod', '^[0-9]+$');
  text('nameNodeHeapSize', '^[0-9]+$');
  text('nameNodeNewGenHeapSize', '^[0-9]+$');
  text('nameNodeMaxNewGenHeapSize', '^[0-9]+$');
  text('nameNodePermGenHeapSize', '^[0-9]+$');
  text('nameNodeMaxPermGenHeapSize', '^[0-9]+$');
  text('staleInterval', '^[0-9]+$');
  check('readStaleDataNodes');
  check('writeStaleDataNodes');
  text('heartbeatRecheckInterval','^[0-9]+$');
  setfocus('port');

  var hdfsObject = current.cluster.find(current.get('hdfs'));
  if (hdfsObject.object.useFederation) {
    document.getElementById('fedMountPointBox').removeAttribute("hidden");
  } else {
    document.getElementById('fedMountPointBox').setAttribute("hidden", true);
  }
}

