/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopTaskTrackerRole';


function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);
  
  // text('modified', '^[0-9]+$');  
  text('handlerCount', '^[0-9]+$');
  text('portHTTP', '^[0-9]+$');
  text('taskTrackerHeapSize', '^[0-9]+$');
  text('numTasksPerJVM', '^[0-9]+$');
  text('maxMapTasks', '^[0-9]+$');
  text('maxReduceTasks', '^[0-9]+$');
  text('mapJavaOpts', '');
  text('reduceJavaOpts', '');
  check('mapOutputCompress');
  check('mapSpecExecution');
  check('reduceSpecExecution');
  text('maxVirtMemoryChild', '^[0-9]+$');
  text('parallelReduce', '^[0-9]+$');
  text('ttSortBufferMemory', '^[0-9]+$');
  text('ttSortFactor', '^[0-9]+$');
  text('mapOutputCompressCodec', '^[0-9]+$');

  //setfocus('reportAddress');
}

