/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopYARNServerRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  //text('modified', '^[0-9]+$');  
  check('enableACL');

  check('ubertaskEnabled');
  text('ubertaskMaxReduces', '^[0-9]+$');
  text('ubertaskMaxMaps', '^[0-9]+$');

  text('nmHeartbeatInterval', '^[0-9]+$');
  text('nmLivenessInterval', '^[0-9]+$');

  check('enableLogAggregation');
  text('adminACL', '');
  text('resourceManagerPort', '^[0-9]+$');

  text('appManagerRequestsCount', '^[0-9]+$');
  text('appMasterMaxAttempt', '^[0-9]+$');

  text('resourceTrackerPort', '^[0-9]+$');
  text('resTrackerHandlerCount', '^[0-9]+$');

  text('adminPort', '^[0-9]+$');
  text('webAppPort', '^[0-9]+$');
  text('webAppHttpsPort', '^[0-9]+$');

  text('mapredJobhistoryPort', '^[0-9]+$');
  text('mapredJobhistoryWebAppHttpsPort', '^[0-9]+$');
  text('mapredJobhistoryWebAppPort', '^[0-9]+$');

  text('yarnTimelinePort','^[0-9]+$');
  text('yarnTimelineWebAppPort','^[0-9]+$');
  text('yarnTimelineWebAppHttpsPort','^[0-9]+$');

  text('schedulerPort', '^[0-9]+$');
  text('schedulerClass', '');
  text('schedulerMinAllocMb', '^[0-9]+$');
  text('schedulerMinAllocVcores', '^[0-9]+$');
  text('schedulerMaxAllocMb', '^[0-9]+$');
  text('schedulerMaxAllocVcores', '^[0-9]+$');
  text('schedulerHandlerCount', '^[0-9]+$');

  text('resourceManagerHeapSize', '^[0-9]+$');
  text('yarnHeapSize', '^[0-9]+$');
  text('jobHistoryHeapSize', '^[0-9]+$');
  text('proxyServerHeapSize', '^[0-9]+$');
//  stringlist('nodesInclude', '');
//  stringlist('nodesExclude', '');

  setfocus('adminACL');
}

