/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dockerDeployment;
var myDialog;
var dock;

var current;

var newEdit;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  dockerDeployment = myDialog.arguments.docker;
  if(myDialog.arguments.object <= 0) {
    newEdit = true;
    setDialogTitle("Add Registry")
    //refresh();
  } else {
    newEdit = false;
    // current = cluster.find(myDialog.arguments.object);
    // if(isObject(current)) {
    //   old = current.old(false, true);
    //   refresh();
    // } else {
    //   dock.displayError("Key no longer valid");
    //   myDialog.doCancel();
    //   close();
    // }
    // if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
    //   document.getElementById("userID").setAttribute('disabled', 'true');
    //   document.getElementById("userID").setAttribute('readonly', 'true');
    // }
  }

  //old = current.old(false, true);
  //refresh();
}

function ok() {
  if(!window.closed) {
    var registryName = document.getElementById('registryName').value;
    //println(registryName)
    if(blank(registryName)) {
      dock.displayError("Registry name cannot be empty");
      return;
    }
    if(newEdit) {
      //println(dockerDeployment.registries);
      dockerDeployment.addRegistry(registryName);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    //if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}


