/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var role;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  current = myDialog.arguments.object;
  refresh();
}

function refresh() {
  text('maxPods', '^[0-9]+$');
  text('maxDeadContainers', '^[0-9]+$');
  text('maxDeadContainersPerContainer', '^[0-9]+$');
  text('minContainerTtlDuration');
  text('fileCheckFrequency');
  text('httpCheckFrequency');
  text('nodeStatusUpdateFrequency');
  text('streamingConnectionIdleTimeout');
  text('syncFrequency');
  text('imageGcHighThreshold');
  text('imageGcLowThreshold');
  text('lowDiskSpaceThreshold');
}

function ok() {
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}

