/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var cluster;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    cluster = use;
    var kubes = cluster.find("KubeCluster");
    if(kubes.length < 1) return;
    current = kubes[0];
  }
  println("Refresh kube settings");

  text('name', '^[a-zA-Z]');
  text('kubeConfig', '');

  text('authorizationPolicyFile', '^[a-zA-Z]');
  kenum('authorizationMode', ['ABAC', 'AlwaysAllow', 'AlwaysDeny', 'Webhook']);

  text('ca', '^[a-zA-Z]+$');
  text('kubernetesCertificate', '^[a-zA-Z]');
  text('kubernetesKey', '^[a-zA-Z]');

  text('insecureApiPort', '^[0-9]+$');
  text('secureApiPort', '^[0-9]+$');
  text('kubeletPort', '^[0-9]+$');
  text('healthCheckPort', '^[0-9]+$');
  text('controllerPort', '^[0-9]+$');
  text('schedulerPort', '^[0-9]+$');
  text('kubeConfigTemplate');
}

