/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function onLoad() {
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if (!!use) {
    current = use;
  }

  var cluster = current;
  if (!current.isCluster) {
    cluster = current.cluster;
  }

  var kubes = cluster.find("KubeCluster");
  if (kubes.length > 0) {
    var kube = kubes[0];
    showKube();
  } else {
    hideKube();
    return true;
  }
}

function addKubeClusterWizard() {
  var win = dock.windowMediator.getMostRecentWindow('addkubeclusterwizard');
  if ( win ) {
    dock.windowMediator.getMostRecentWindow('addkubeclusterwizard').focus();
    return false;
  }

  var tabpanel = document.getElementById('tabpanels');
  if(tabpanel) {
    var tabs = tabpanel.children;
    for(var i=0; i < tabs.length; i++) {
      if(tabs[i].id=="tasks_iframe") {
        var doc = tabs[i].contentDocument
        if(doc) {
          var box = doc.getElementById('disablingProgress');
          if(box) {
            box.setAttribute('hidden', true);
          }
        }
      }
    }
  }

  var args = new Object();
  args['cluster'] = current;
  var d = new dock.cvDialog("kube/addkubeclusterwizard.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);

}

