/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  setDialogTitle(myDialog.arguments.title)
  document.getElementById("question").setAttribute('value', myDialog.arguments.question + ':');
  if(typeof(myDialog.arguments.extra1) == 'string') {
    document.getElementById("extra1").removeAttribute('hidden');
    document.getElementById("extra1question").setAttribute('value', myDialog.arguments.extra1 + ':');
    window.height += 32;
  }
  document.getElementById("result").setAttribute('value', myDialog.arguments.default);
  document.getElementById("result").focus();

  
  if(myDialog.arguments.width) window.width = parseInt(myDialog.arguments.width);
  if(myDialog.arguments.height) window.height = parseInt(myDialog.arguments.height);
}

function ok() {
  var name = document.getElementById("result").value;
  var extra1 = document.getElementById("extra1result").value;
  if(blank(name)) {
    dock.displayError(myDialog.arguments.question + " cannot be empty");
  } else if(myDialog.arguments.known.find(name) >= 0) {
    dock.displayError("That " + myDialog.arguments.question + " is already taken");
  } else if(!window.closed) {
    close();
    myDialog.onOk(name, extra1);
  }
}

function cancel() {
  close();
}
