/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);

}

function refresh(use) {
  if(!!use) current = use;

  println("Refresh node disksetup" + ' - ' + document.documentURI);
  var category = 0;
  var xml;
  var ds = current.get("disksetup");
  if(diskSetup_empty(ds)) {
    category = current.cluster.find(current.get('category'));
    if(category) {
      ds = category.get("disksetup");
      xml = '<!-- Inherited from category ' + category.resolveName() + " -->\n\n" + ds;
    } else {
      xml = "<!-- No category -->\n\n";
    }
  } else {
    xml = ds;
  }
  var obj = document.getElementById("disksetup");
  obj.value = xml;
  if(category) {
    obj.setAttribute('disabled', true);
    document.getElementById('validate').setAttribute('disabled', true);
    document.getElementById('clear').setAttribute('disabled', true);
  } else {
    obj.removeAttribute('disabled');
    document.getElementById('validate').removeAttribute('disabled');
    document.getElementById('clear').removeAttribute('disabled');
  }
  obj.addEventListener("change", disksetup_change, true);
  obj.addEventListener("keypress", disksetup_keypress, true);
}

