/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function selectVirtualInterfaceConfigDefault() {
  printallR(wizard.config.modules.neutron);
  if(wizard.config.modules.neutron.l2_agent == 'OVS' && 
     wizard.config.modules.neutron.user_network_isolation == 'VLAN') {
    return 'NOTHING';
  } else {
    return wizard.config.modules.neutron.new_virtual_host_net_interface_default_network_type;
  }
}

function selectVirtualInterfaceConfigMethods() {
  if(wizard.config.modules.neutron.l2_agent == 'OVS' && 
     wizard.config.modules.neutron.user_network_isolation == 'VLAN') {
    return [
      { 'value': 'NEW_DEDICATED', 'label': 'dedicated' },
      { 'value': 'NOTHING', 'label': 'later' },
    ];
  } else {
    return [
      { 'external': 'false', 'value': 'NEW_SHARED',  'label': 'shared' },
      { 'value': 'NEW_DEDICATED', 'label': 'dedicated' },
      { 'value': 'NOTHING', 'label': 'later' },
    ];
  }
}
