/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function hideOpenStack() {  
  if(document.getElementById('noopenstack').hasAttribute('hidden')) {
    document.getElementById('tabbox').setAttribute('hidden', true);
    document.getElementById('noopenstack').removeAttribute('hidden');
  }
}

function showOpenStack() {
  if(document.getElementById('tabbox').hasAttribute('hidden')) {
    document.getElementById('tabbox').removeAttribute('hidden');
    
    // HACK to reset XUL element properties
    var originalTabbox = document.getElementById('tabbox');
    var clonedTabbox = originalTabbox.cloneNode(true);
    originalTabbox.parentNode.replaceChild(clonedTabbox, originalTabbox);

    document.getElementById('noopenstack').setAttribute('hidden', true);
  }
}

function postrefresh(use) {
  if (!!use) {
    current = use;
  }

  var cluster = current;
  if (!current.isCluster) {
    cluster = current.cluster;
  }
  var openstacks = cluster.find("OpenStack");
  if (openstacks.length > 0) {
    var openstack = openstacks[0];
    showOpenStack();
  } else {
    hideOpenStack();
    return true;
  }
}

function addWizard() {
  var win = dock.windowMediator.getMostRecentWindow('addOpenStackSetupWizard');
  if ( win ) {
    dock.windowMediator.getMostRecentWindow('addOpenStackSetupWizard').focus();
    return false;
  }
  var args = new Object();
  args['cluster'] = current;
  var d = new dock.cvDialog("chrome://cmgui/content/openstack/install/wizard.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
