/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh otherdevice settings" + ' - ' + document.documentURI);
  text('hostname', '(?!^[0-9]+$)^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]*[a-zA-Z0-9])$', '', true);
  text('tag');
  text('model');
  var obj = document.getElementById('model');
  if(dock.baseChildTypeCheck(current.object, 'RackSensor')) {
    obj.setAttribute('disabled', true);
  } else {
    obj.removeAttribute('disabled');
  }
  partial('mac', ':', '^[0-9a-fA-F]{2}$', '', true, '00:00:00:00:00:00', 0, '6..21', '00');
//   partial('ip', '.', dock.REGEX_IPv4);
  text('ip', dock.REGEX_IPv6);
  resolve('network', 'Network', '', true);

  rackPostionSettings();

  var list = ['none', 'apc', 'custom'];
  var pwctl = current.get('powerControl');
  if(startswith(pwctl, 'ipmi')) {
    list.push(pwctl);
  }
  kenum('powerControl', list);
  text('customPowerScript');
  text('customPowerScriptArgument');
  text('customPingScript');
  text('customPingScriptArgument');
  text('userdefined1');
  text('userdefined2');
  text('revision');
  createApc();
  if(current.object.childType == 'GenericDevice') stringlist('additionalHostnames', "Additional Hostname:", dock.REGEX_HOSTNAME, 210, 350);
}
