/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var KEY_ENTER = 13;

var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  setDialogTitle(myDialog.arguments.title)
  if (myDialog.arguments.askpwd) {
    document.getElementById("userlabel").setAttribute('value', 'Username: ');
    document.getElementById("username").setAttribute('value', myDialog.arguments.cluster.username);
  } else {
    document.getElementById("result").removeAttribute('type');
  }
  document.getElementById("question").setAttribute('value', myDialog.arguments.question);
  document.getElementById("result").focus();

}

function ok() {
  var name = document.getElementById("result").value;
  if(blank(name)) {
    dock.displayError(myDialog.arguments.question + " cannot be empty");
  } else {
    close();
    myDialog.onOk(myDialog.arguments.cluster, name);
  }
}

function cancel() {
  close();
  myDialog.onCancel(myDialog.arguments.cluster);
}

function keypress(event) {
  if(event.keyCode == KEY_ENTER) {
    ok();
  }
}
