/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var myDialog;

var fieldname = false;
var displayInTree = false;
var subtype = 'Node';
var singular = 'node';
var plural = 'nodes';
var extraName = "''";
var nodeSelectionProperties = [['','', false],
				 ['hostname', 'hostname', false],
				 ['MAC', 'mac', false],
				 ['tag', 'tag', false],
				 ['category', 'category', true],
				 ['installmode', 'installMode', false],
				 ['rack', 'rack', true],
				 ['position', 'rackPosition', false]];
var belongs = '0';
var noloop = 'true';
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

var currentnodes = new Array();
var nodesIndex = '';
var excludeFunction = undefined;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  var allnodeslabel = "All Nodes";
  var groupnodeslabel = "Selected Nodes";
  current = myDialog.arguments.cluster;
  if(myDialog.arguments.preselected_nodes) {
    currentnodes = myDialog.arguments.preselected_nodes;
  }
  document.getElementById('allnodeslabel').value = allnodeslabel;
  document.getElementById('groupnodeslabel').value = groupnodeslabel;
  refresh(current);
  if(currentnodes.length > 0) {
    previewPuppetManifest(false);
  }
  
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node selection window" + ' - ' + document.documentURI);
  //nodesIndex = 'Overlaynodes';
  deviceselect(excludeFunction);
  //var revert_button = document.getElementById('revert');
  //if(revert_button) {
  //  revert_button.setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  //}
}

function cancelOk() {
  myDialog.onOk();
  close();
}

function previewPuppetManifest(noop) {
  var preview = new PuppetPreview();
  preview.preview(noop,currentnodes);
}

