/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  var cluster = myDialog.arguments.cluster;
  current = myDialog.arguments.job;
  current = new dock.cvObject(cluster, current);
  refresh();
}

function refresh() {
  text('jobID', '^');
  text('jobname', '^');
  document.getElementById('nodes').value =  commaListToDotFormat(current.get('nodes'), new RegExp("\\..*$"));
  text('username', '^');
//   text('priority', '^');
  text('rundirectory', '^');
  text('scriptFile', '^');
  text('usergroup', '^');
  text('account', '^');
  text('submittime', '^');
  text('maxWallClock', '^');
  displayfunction('runWallClock', 'formatDHMS(value);');
  text('runWallClock', '^');
  if(current.get('numberOfProcesses') > 0) text('numberOfProcesses', '^');
  if(current.get('numberOfNodes') > 0) text('numberOfNodes', '^');
  if(current.get('memoryUse') > 0) displayfunction('memoryUse', 'formatKMGselect(value, "B");');
//   text('dependencies', '^');
}

function cancel() {
  close();
}
