/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock

function onLoad() {
  dock = getDock();
  println("Showtext initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  setDialogTitle(myDialog.arguments.title);
  if (myDialog.arguments.style) {
    document.getElementById('message').setAttribute('style', myDialog.arguments.style);
  }
  document.getElementById('message').value = myDialog.arguments.text;
  document.getElementById('ok').focus();

  if(myDialog.arguments.width) window.width = parseInt(myDialog.arguments.width);
  if(myDialog.arguments.height) window.height = parseInt(myDialog.arguments.height);
}

function showTextCopy() {
    var element = document.getElementById("message");
    var copy_text = element.value;
    //An XPCOM wrapper for the data which you want to put on the clipboard.
    var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    if (!str) return false;
    str.data = copy_text;
    //This object is the component @mozilla.org/widget/transferable;1 which implements the interface nsITransferable.
    var trans = Components.classes["@mozilla.org/widget/transferable;1"].
        createInstance(Components.interfaces.nsITransferable);
    if (!trans) return false;
    trans.addDataFlavor("text/unicode");
    trans.setTransferData("text/unicode", str, copy_text.length * 2);
    var clipid = Components.interfaces.nsIClipboard;
    var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
    if (!clip) return false;
    clip.setData(trans, null, clipid.kGlobalClipboard);
}

