/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh softwareimage settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  text('name', '^[a-zA-Z]', '', true);
  text('path', '');
  text('kernelParameters', '');
  lookup('kernelVersion', 'cmpart', 'getSoftwareImageKernelVersions');

  autorefresh('path');

  text('SOLPort', '');
  kenum('SOLSpeed', ['115200', '57600', '38400', '19200', '9600', '4800', '2400', '1200']);
  check('enableSOL');
  check('SOLFlowControl');
  check('locked');
  text('revision');
  
  if(parent.detached) {
    document.getElementById('saverevert').setAttribute('hidden', true);
    var fields = ['name', 'path', 'kernelParameters', 'kernelVersion', 'SOLPort', 'SOLSpeed', 'enableSOL', 'SOLFlowControl', 'locked', 'revision'];
    for(var i = 0; i < fields.length; i++) {
      document.getElementById(fields[i]).setAttribute('disabled', true);
    }
  }
}
