/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var fieldname = 'members';
var displayInTree = true;
var subtype = 'Switch';
var singular = 'switch';
var plural = 'switches';
var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['rack', 'rack.rack', true],
            ['position', 'rack.position', false]];
var belongs = 'current.cluster.belongsToStack(key)';
var noloop = 'a[i].get("members").length == 0';
var extraName = "''";
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh nodegroup settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);

  subtype = current.get('childType');
  current.cluster.belongsToStackMap(subtype);
  deviceselect();
}
