/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh category settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  text('name', '^[a-zA-Z]', '', true);
//   partial('defaultGateway', '.', '^(25[0-5]|2[0-4][0-9]|[0-1]?[0-9]?[0-9])$');
  text('defaultGateway', dock.REGEX_IPv6);

  var noRevisions = 'function(image) { \
    if(image.get("parentSoftwareImage")) return true; \
    return false; \
  }'
  
  resolve('softwareImageProxy', 'SoftwareImage', 'parentSoftwareImage', 0, '', noRevisions);  
  extraeval('softwareImageProxyparentSoftwareImage', 'setSoftwareImageParent(current, old);');
  setSoftwareImageParent(current, 0);
  
  kenum('installMode', ['AUTO', 'FULL', 'MAIN', 'NOSYNC']);
  kenum('newNodeInstallMode', ['AUTO', 'FULL', 'MAIN', 'NOSYNC']);
  kenum('useExclusivelyFor', ['', 'HPC', 'Hadoop', 'Ceph', 'OpenStack', 'Nothing']);

  resolve('managementNetwork', 'Network', '', true);

  check('installBootRecord');
  check('dataNode');

//   iplist('nameServers', "Name server:");
  stringlist('nameServers', "Name server:", dock.REGEX_IPv6);
  stringlist('timeServers', "Time server:");
  stringlist('searchDomains', "Search domain:");

  text('bmcUserID');
  text('bmcUserName');
  text('bmcPassword');

  text('excludeListFull');
  text('excludeListSync');
  text('excludeListUpdate');
  text('excludeListGrab');
  text('excludeListGrabnew');
  text('finalize');
  text('initialize');
  text('revision');
  text('cpuspeedGovernor', '^[a-z,]*$');
  
  kenum('interactiveUser', [['ALWAYS', 'Always'], ['ONLYWHENJOB', 'Only when user has a job running'], ['NEVER', 'Never']]);
}
