/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function setRole(role, category) {
  var obj = document.getElementById('has' + role.childType);
  if(obj) {
    var one = setGenericRole(role, category, obj);
    if(role.childType == 'CephMonitorRole') {
      role_text('dataPath', one, category);
    } else if(role.childType == 'RadosGatewayRole') {
      var o = document.getElementById('keystoneAuthLabel');
      if(one.get('enableKeystoneAuthentication')) {
        o.setAttribute('value', 'enabled');
      } else {
        o.setAttribute('value', 'disabled');
      }
    } else if(role.childType == 'CephOSDRole') {
      for(var i = 0; i < role.osdassociations.length; i++) {
        if(!role.osdassociations[i].toBeRemoved) {
          role_text('osdassociations_' + i, one, category, '', 'name');
        }
      }
    } else {
      println("Warning unsupported ceph role: " + role.childType);
    }
  } else {
    println("Warning unknown ceph role: " + role.childType);
  }
}
