/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var fieldname = 'members';
var displayInTree = true;
var subtype = 'Device';
var singular = 'device';
var plural = 'devices';
var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['category', 'category', true],
            ['installmode', 'installMode', false],
            ['rack', 'rack.rack', true],
            ['position', 'rack.position', false]];

var belongs = 'current.cluster.belongsToChassis(key)';
var noloop = 'true';
var extraName = "''";
var extraEvalOnAdd = 'current.cluster.updateRack = true;';
var extraEvalOnRemove = 'current.cluster.updateRack = true;';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  notOfType.push('Chassis');
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh chassis members settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);

  current.cluster.belongsToChassisMap();
  deviceselect();
}
