'user strict';
global.__base = __dirname + '/../../';
var test = require('unit.js');
var expect    = require("chai").expect;
var Context = require('cm-context');

var context;
var wizard_module_ctx;
var wizard;

function Element(parent) {
  this.children = [];
  this.parentElement = parent;
  this.appendChild = function(elem) {
    this.children.push(elem);
  };
}

function testSetup() {
  context = new Context(global.__base);
  wizard_module_ctx = context.load('cm-setup/wizard.js');
  wizard_module_ctx = context.load('cm-setup/deploy.js');
  wizard_module_ctx = context.load('cloud/addnode/wizard.js');
  wizard = new context.context.NodeCreationWizard(); 
  context.context.printall = function(x) {
  };
}

describe('Cloud Node Extension Wizard', function(){
  it('summary.getIntersectionOfInstanceTypes determines overlap of types for set of regions', function() {
    testSetup();
  });

  it('summary.createDefaultTypeItems for set of regions', function() {
    testSetup();
  });
});

