/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var cluster;
var myDialog;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  
  myDialog = dock.dialogs.list[index];
  cluster = myDialog.arguments.cluster;

  document.getElementById('message').setAttribute('value', 'Modify drain actions for: ' + dotFormatKeys(cluster, myDialog.arguments.nodes));

  current = new dock.cvThreshold();
  current = new dock.cvObject(cluster, current);
  refresh();
  
  setDialogTitle('Drain nodes actions')

}

function refresh() {
  threshActionList('actionConfs', 'Append action:', '^', false);
}

function drain() {
  var addActions = current.get('actionConfs');
  var removeActions = new Array();
  var clearActions = document.getElementById('clearAll').checked;
  
  myDialog.onOk(addActions, removeActions, clearActions);
  close();
}