/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function openDevice() {
  var keys = [current.get('uniqueKey')];
  var status = new dock.cvDevStatus();
  status.status = 'OPENING';
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'setStatusForDeviceArray', [keys, status], function(code, data) {
    if(code == 0) {
      if(!data) {
        dock.displayError("Open failed");
      }
    } else {
      dock.jsonCallError(this, code, data);
    }
    refresh();
  }, current);
}

function closeDevice() {
  var keys = [current.get('uniqueKey')];
  var status = new dock.cvDevStatus();
  status.status = 'CLOSED';
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'setStatusForDeviceArray', [keys, status], function(code, data) {
    if(code == 0) {
      if(!data) {
        dock.displayError("Open failed");
      }
    } else {
      dock.jsonCallError(this, code, data);
    }
    refresh();
  }, current);
}

