/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh gpuunit settings" + ' - ' + document.documentURI);
  text('hostname', dock.REGEX_HOSTNAME, '', true);
  text('tag');
  partial('mac', ':', '^[0-9a-fA-F]{2}$', '', true, '00:00:00:00:00:00', 0, '6..21', '00');

  text('ip', dock.REGEX_IPv6);
  resolve('network', 'Network', '', true);
  text('bmcUserName');
  text('bmcPassword');

  rackPostionSettings();

//   resolve('owners_0', 'Node', '', true);
//   resolve('owners_1', 'Node', '', true);
  resolveList('owners', 'Owner', 'Node', '', '');

  var list = ['none', 'ipmi', 'apc', 'custom'];
  kenum('powerControl', list);
  
  text('customPowerScript');
  text('customPowerScriptArgument');
//   text('customPingScript');
//   text('customPingScriptArgument');
  text('userdefined1');
  text('userdefined2');
  text('revision');
  createApc();
}
