/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

const roleName = 'HadoopCassandraRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  text('storagePort','^[0-9]+$');
  text('sslStoragePort','^[0-9]+$');
  text('nativeTransportPort','^[0-9]+$');
  text('nativeTransportPortSsl','^[0-9]+$');
  text('jmxPort','^[0-9]+$');
  text('numTokens','^[0-9]+$');
  text('endpointSnitch','');
  text('seedProviderSeeds','');
  text('commitlogDirectory','');
  stringlist('dataFileDirectories','Data File Directory:');
  text('savedCachesDirectory','');
  text('hintsDirectory','');
  text('maxHeapSize','^[0-9]+[KMGTP]$');
  text('heapNewsize','^[0-9]+[KMGTP]$');
  text('jolokiaPort','^[0-9]+$');
  text('listenAddress','');
  text('listenInterface','');
  text('rpcAddress','');
  text('rpcInterface','');
  check('startThriftRpc');
  text('rpcThriftPort','^[0-9]+$');
}
