/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopSparkWorkerRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  text('workerDir', '');  
  text('port', '^[0-9]+$');
  text('webPort', '^[0-9]+$');
  text('memoryForExecutors', '^[0-9]+(M|G)$');
  text('daemonMemory', '^[0-9]+(M|G)$');
  text('numCores', '^[0-9]+$');
  text('numInstances', '^[0-9]+$');
  check('cleanupEnabled');
  text('cleanupInterval', '^[0-9]+$'); // type U  default="1800"
  text('cleanupAppDataTtl', '^[0-9]+$'); // type U, default="604800"

}

