/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopYARNClientRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);
  
  // text('modified', '^[0-9]+$');  
  stringlist('localDirs', 'Localization directories:');
  stringlist('logDirs', 'Log directories:');
  check('nodeManagerLogAggregation');  
  text('logRetainSec', '^[0-9]+$');
  text('appLogDirSuffix', '');
  text('appLogDir', '');

  text('nodeManagerHeapSize', '^[0-9]+$');
  text('resourceMemMb', '^[0-9]+$');
  check('nodeManagerPmem');
  check('nodeManagerVmem');
  text('vmpmRatio', '');

  text('nodeManagerCpuVcores', '^[0-9]+$');
  text('nodeManagerMonitorInterval', '^[0-9]+$');
  text('nodeManagerContThrCount', '^[0-9]+$');
  text('nodemanagerPort', '^[0-9]+$');
  text('webAppHttpsPort', '^[0-9]+$');
  text('webAppPort', '^[0-9]+$');
  text('localizerPort', '^[0-9]+$');

  text('auxServices', '');
  text('nodeManagerDockerContainer', '');
  text('auxServicesShuffleClass', '');
  text('shufflePort', '^[0-9]+$');

  text('yarnAppMRJVM', '');
  text('yarnAppMRVcores', '^[0-9]+$');
  text('yarnAppMRMemoryMB', '^[0-9]+$');
  text('yarnAppMRHandlerCount', '^[0-9]+$');

  text('nmMRMapMemory', '^[0-9]+$');
  text('nmMRReduceMemory', '^[0-9]+$');
  text('nmMRMapVcores', '^[0-9]+$');
  text('nmMRReduceVcores', '^[0-9]+$');
  text('nmMRMapJVM', '');
  text('nmMRReduceJVM', '');
  text('nmMRJobMaps', '^[0-9]+$');
  text('nmMRJobReduces', '^[0-9]+$');
  check('nmMRMapSpec');
  check('nmMRReduceSpec');

  setfocus('nodemanagerPort');

}

