/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var role;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  role = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  refresh();
}

function refresh() {
  text('loopDataSize');
  text('loopMetadataSize');
  text('baseSize');
  text('poolDevice');
  text('filesystem');
  text('blockSize');
  stringlist('mountOptions', '');
  stringlist('mkfsArguments', '');
  check('blkDiscard');
}

function ok() {
  if(role.get('modified')) current.set('modified', true);
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}

