/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh mic settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  
  var settings = current.get('micSettings');  
  if(settings.childType == 'XeonPhiSettings') {
    text('micSettings', '^', 'console');
    text('micSettings', '^', 'extraCommandLine');
    text('micSettings', '^', 'rootDevice');
    text('micSettings', '^', 'rootDeviceType');
    text('micSettings', '^', 'osImageKernel');
    text('micSettings', '^', 'osImageAddressMap');
    text('micSettings', '^[0-9]+$', 'shutdownTimeout');
    text('micSettings', '^', 'powerManagement');
    check('micSettings', false, 'verboselogging');
    check('micSettings', false, 'bootOnStart');
    
    text('micSettings', '^', 'cgroupMemory');
    text('micSettings', '^', 'base');
    text('micSettings', '^', 'typeOfBase');
    text('micSettings', '^', 'commonDir');
    text('micSettings', '^', 'micDir');

    kenum('micSettings', ['nochange', 'none', 'merge', 'overlay'], 'userAuthenticationType');

    text('micSettings', '^', 'rpmsDir');
    kenum('micSettings', ['none', 'shadow'], 'updatePassType');
    check('micSettings', false, 'addMacs');
    check('micSettings', false, 'modifyHostsFileOnHost');
    check('micSettings', false, 'modifyHostsFileOnMic');
    check('micSettings', false, 'noUserHomeCreation');
    check('micSettings', false, 'disableLdap');

    text('micSettings', '^', 'crashDumpDir');
    text('micSettings', '^[0-9]+$', 'crashDumpLimit');
    // TODO
  } else {
    println('--------------- NOT XEON PHI SETTINGS -----------------');
    printall(settings);
  }
}
