/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'Metric';
var singular = 'metric';
var plural = 'metrics';
var editfile = 'editmetric.xul';

function createTreeItem(one) {
  var item = new Object();
  item['modified'] = one.get('modified');
  item['key'] = one.get('uniqueKey');
  item['name'] = one.get('name');
  item['metricClass'] = one.cluster.metricTypeToName(true, one.get('metricClass'));
  if(one.get('isCustom')) {
    item['command'] = one.get('command');
  } else {
    item['command'] = '<built in>';
  }
  item['disabled'] = one.get('disabled');
  return item;
}

function newMetricCollection() {
  var args = new Object();
  args['cluster'] = current;
  args['metric'] = 0;
  var d = new dock.cvDialog("addmetriccollection.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
