/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleNetworkRole() {
  this.addTitle = "Add OpenStack Network Configuration";
  this.editTitle = "Edit OpenStack Network Configuration";

  this.getCurrentObject = function(editorController) {

    if(editorController.isAdd()) {
      println("Error: it is not implemented!");
    } else {
      return editorController.myDialog.arguments.subobject;
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    text('dnsmasqCustom');
  };

  this.inputCheck = function(editorController) {
    return true;
  };
}

EditorRuleNetworkRole.prototype = new EditorRuleBase();
EditorRuleNetworkRole.prototype.constructor = EditorRuleNetworkRole;
