/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.manageUsers = new WizardScreen();

wizard.manageUsers.initDefaultConfig = function() {
  println('init wizard.manageUsers.initDefaultConfig');

//  wizard.common.setConfig(wizard.config.modules.keystone, 'auth_backend', 'mysql');
};

wizard.manageUsers.enter = function() {
  function initManageUsers() {
    switch(wizard.config.modules.keystone.auth_backend) {
      case 'mysql':
        wizard.manageUsers.setManageUser(0);
        break;
//      case 'mysql2':
//        wizard.manageUsers.setManageUser(1);
//        break;
      case 'hybrid':
        wizard.manageUsers.setManageUser(1);
        break;
      case 'ldap_bright':
        wizard.manageUsers.setManageUser(2);
        break;
//      case 'ldap_ad':
//        wizard.manageUsers.setManageUser(4);
//        break;
      default:
        wizard.manageUsers.setManageUser(0);
        break;
    }
  }
  println('enter wizard.manageUsers.enter');

  if (!wizard.manageUsers.started) {
    wizard.manageUsers.started = true;

    initManageUsers();
  }
};

wizard.manageUsers.forward = function(automatic) {
  println('forward wizard.manageUsers.forward');

  if (document.getElementById('manageUsers-mysql').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.keystone, 'auth_backend', 'mysql');
//  } else if (document.getElementById('manageUsers-mysql2').getAttribute('on') === 'true') {
//    wizard.common.setConfig(wizard.config.modules.keystone, 'auth_backend', 'mysql2');
  } else if (document.getElementById('manageUsers-hybrid').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.keystone, 'auth_backend', 'hybrid');
  } else if (document.getElementById('manageUsers-ldapBright').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.keystone, 'auth_backend', 'ldap_bright');
//  } else if (document.getElementById('manageUsers-ldapAD').getAttribute('on') === 'true') {
//    wizard.common.setConfig(wizard.config.modules.keystone, 'auth_backend', 'ldap_ad');
  }

  printallR('auth_backend: ' + wizard.config.modules.keystone.auth_backend);

  return wizard.manageUsers.error;
};

wizard.manageUsers.setManageUser = function(choice) {
  setSimpleRadio(choice, [
    'manageUsers-mysql',
//    'manageUsers-mysql2',
    'manageUsers-hybrid',
    'manageUsers-ldapBright',
//    'manageUsers-ldapAD'
  ]);
};
