/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.networkLayer2Agent = new WizardScreen();

wizard.networkLayer2Agent.initDefaultConfig = function() {
  println('init wizard.networkLayer2Agent.initDefaultConfig');

//  wizard.common.setConfig(wizard.config.modules.neutron, 'l2_agent', 'OVS');
};

wizard.networkLayer2Agent.enter = function() {
  function initLayer2NetworkAgent() {
    if (wizard.config.modules.neutron.l2_agent==='OVS') {
      wizard.networkLayer2Agent.setLayer2NetworkAgent(0);
    } else {
      wizard.networkLayer2Agent.setLayer2NetworkAgent(1);
    }
  }
  println('enter wizard.networkLayer2Agent.enter');

  if (!wizard.networkLayer2Agent.started) {
    wizard.networkLayer2Agent.started = true;

    initLayer2NetworkAgent();
  }
};

wizard.networkLayer2Agent.forward = function(automatic) {
  println('forward wizard.networkLayer2Agent.forward');

  if (document.getElementById('networkLayer2Agent-OVS').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.neutron, 'l2_agent', 'OVS');
  } else {
    wizard.common.setConfig(wizard.config.modules.neutron, 'l2_agent', 'LB');
  }

  printallR('l2_agent: ' + wizard.config.modules.neutron.l2_agent);

  return wizard.networkLayer2Agent.error;
};

wizard.networkLayer2Agent.setLayer2NetworkAgent = function(choice) {
  setSimpleRadio(choice, ['networkLayer2Agent-OVS', 'networkLayer2Agent-LB']);
};
