/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var deviceName = 'device';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh device tasks" + ' - ' + document.documentURI);

  var apc = current.get('powerDistributionUnits');
  if(current.get('powerControl') == 'apc') {
    document.getElementById('poweron').setAttribute('disabled', apc.length == 0);
    document.getElementById('poweroff').setAttribute('disabled', apc.length == 0);
    document.getElementById('powerreset').setAttribute('disabled', apc.length == 0);
  } else if(current.get('powerControl') == 'none') {
    document.getElementById('poweron').setAttribute('disabled', true);
    document.getElementById('poweroff').setAttribute('disabled', true);
    document.getElementById('powerreset').setAttribute('disabled', true);
  } else {
    document.getElementById('poweron').setAttribute('disabled', false);
    document.getElementById('poweroff').setAttribute('disabled', false);
    document.getElementById('powerreset').setAttribute('disabled', false);
  }
}

function locateInRack() {
  current.cluster.locate(current);
}
