/* Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function puppetGetLogFromNode(current,nodeo,apply_session=0, run=0, noop=false) {
  var node = parseInt(nodeo.get('uniqueKey'));
  var hostname = nodeo.get('hostname');
  var self = this;
  var cluster = current.isCluster?current:current.cluster;
  dock.workerpool.getWorker(cluster.actualurl).call('cmpuppet', 'getPuppetOutput', [ node, apply_session, run, noop, [ true, true ] ], 
       function(code, data) {
          if(code == 0) 
           {   
             var args = new Object();
             var d = new dock.cvDialog("chrome://cmgui/content/puppet/puppetlog.xul", args);
             args['config_success'] = data.success[0];
             args['log_success']    = data.success[1];
             args['config']         = data.content[0];
             args['hostname']       = hostname;
             args['log']            = data.content[1].replace(/\x1B.*?m/g,'');
             dock.dialogs.showDialog(d);
          } else {
              dock.jsonCallError(this, code, data);
          }
          dock.unwaitIcon();
      }, current);
}


