/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock

function onLoad() {
  dock = getDock();
  println("Question initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  document.getElementById('message').value = myDialog.arguments.question;
  if(typeof(myDialog.arguments.check) != 'undefined') {
    document.getElementById('check').setAttribute('hidden', false);
    document.getElementById('check').setAttribute('label', myDialog.arguments.check);
    document.getElementById('check').checked = myDialog.arguments.checked;
  }

  if(typeof(myDialog.arguments.yes) != "undefined") document.getElementById('yesbutton').setAttribute('disabled', myDialog.arguments.yes);
  if(typeof(myDialog.arguments.no) != "undefined") document.getElementById('nobutton').setAttribute('disabled', myDialog.arguments.no);
  if(typeof(myDialog.arguments.cancel) != "undefined") document.getElementById('cancelbutton').setAttribute('hidden', myDialog.arguments.cancel);

  if(typeof(myDialog.arguments.yeslabel) != "undefined") document.getElementById('yesbutton').setAttribute('label', myDialog.arguments.yeslabel);
  if(typeof(myDialog.arguments.nolabel) != "undefined") document.getElementById('nobutton').setAttribute('label', myDialog.arguments.nolabel);
  if(typeof(myDialog.arguments.cancellabel) != "undefined") document.getElementById('cancelbutton').setAttribute('label', myDialog.arguments.cancellabel);

  if(typeof(myDialog.arguments.yesaccesskey) != "undefined") document.getElementById('yesbutton').setAttribute('accesskey', myDialog.arguments.yesaccesskey);
  if(typeof(myDialog.arguments.noaccesskey) != "undefined") document.getElementById('nobutton').setAttribute('accesskey', myDialog.arguments.noaccesskey);
  if(typeof(myDialog.arguments.cancelaccesskey) != "undefined") document.getElementById('cancelbutton').setAttribute('accesskey', myDialog.arguments.cancelaccesskey);
  
  document.getElementById('yesbutton').focus();

}

function onClose() {
  if(myDialog.onClose) myDialog.onClose();
}

function yes() {
  close();
  if(myDialog.onOk) {
    if(myDialog.arguments.check) {
      myDialog.onOk(document.getElementById('check').checked);
    } else {
      myDialog.onOk();
    }
    if(myDialog.onClose) myDialog.onClose();
  }
}

function no() {
  close();
  if(myDialog.onNo) myDialog.onNo();
  if(myDialog.onClose) myDialog.onClose();
}

function cancel() {
  close();
  if(myDialog.onCancel) myDialog.onCancel();
  if(myDialog.onClose) myDialog.onClose();
}
