/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function updateRackSubTree(node, old) {
  var rack = node.get('rack').rack;
  if(old != rack) {
    if(old != 0) {
      var tmp = node.cluster.find(old);
      if(tmp) node.removeTreeitemFromParent(tmp.branch);
    }
    if(rack != 0) {
      var tmp = node.cluster.find(rack);
      if(tmp) node.cluster.addOneObject(node, tmp.branch);
    }
    node.cluster.updateRack = true;
  }
}

function updateRackDraw(node, old) {
  node.cluster.updateRack = true;
}
