/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock

function onLoad() {
  dock = getDock();
  println("Select initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  setDialogTitle(myDialog.arguments.title);

  var list = document.getElementById('list');
  var known = myDialog.arguments.known;
  for(var i = 0; i < known.length; i++) {
    var item = document.createElement('listitem');
    item.setAttribute('label', known[i]);
    list.appendChild(item);
  }

}

function ok() {
  if(myDialog.onOk) {
    var list = document.getElementById('list');
    var item = list.selectedItem;
    if(item) {
      myDialog.onOk(item.getAttribute('label'));
    } else {
      dock.displayInfo("Nothing selected");
    }
  }
  close();
}
