/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'KernelModule';
var subfield = 'modules';
var singular = 'kernel module';
var plural = 'kernel modules';
var editfile = 'editkernelmodule.xul';

function postrefresh() {
  if(parent.detached) {
    document.getElementById('saverevert').setAttribute('hidden', true);
  }
}

function createTreeItem(one, i) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['order'] = i;
  item['name'] = one.name;
  item['parameters'] = one.parameters;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  return item;
}

function mkInitrd() {
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmpart', 'createRamdisk', [[current.get('uniqueKey')], false, current.cluster.sessionid, true], function(code, data) {
      if(code == 0) {
        if(data && data[0]) {
          dock.displayInfo("Ramdisk creation started");
        } else {
          dock.displayError("Failed to start the creation of the ramdisk");
        }
      } else {
        if(code) dock.jsonCallError(this, code, data);
      }
    }, current);
}
