/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var detached;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.current;
  detached = myDialog.arguments.detached;
  newEdit = true;
  setDialogTitle("Launch node KVM")
  dock.waitforkvmlabel = document.getElementById('waitforkvmlabel');
  dock.waitforkvmstart = document.getElementById('waitforkvmstart');
  refresh();
}

function refresh() {
  var catnodelist = new Array();
  var nodelist = current.cluster.findNodesIn(current.get('baseType'), current.get('uniqueKey'));
  for ( var i = 0; i < nodelist.length; i++) {
    catnodelist.push(current.cluster.find(nodelist[i]).resolveName());
  }
  var nodelistpp = document.getElementById('categorynodelist');
  var menulist = document.getElementById('categorynodemenulist');
  for ( var i = 0; i < catnodelist.length; i++ ) {
    var menuitem = document.createElement('menuitem');
    menuitem.setAttribute('label', catnodelist[i]);
    nodelistpp.appendChild(menuitem);
    menulist.selectedIndex = parseInt(i);
  }
}

function startKVMCategory(){
  var selectednode = document.getElementById('categorynodemenulist').selectedItem.label;
  current = current.cluster.find("Node", selectednode);
  if (current) {
    dock.waitforkvmlabel.setAttribute('value', "Starting KVM for " + selectednode);
    startKVM();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
