var USE_EVENT_THREAD = 2; // 0 -> no thread, 1 -> remotecm, 2 -> xul-thread
var MAX_GRAPH_REMOTECM = 8;

function cvClusterMock() {
  this.licenseInfo = { 
    licensedOpenStackNodes : 0,
    licensedNodes : 20000
  };
  this.nextLocalKey = 0;
};


cvClusterMock.prototype = { 
  nextLocalKey : 0,
  objects : { 
    'ConfigurationOverlay' : [],
    'PhyscialNode'         : [],
    'NodeCategory'         : [],
    'Node'                 : [],
    'SlaveNode'            : [],
    'SoftwareImage'        : []
  },

  find : function(type) {
    return [];
  }

}

function Configuration(context) {
  this.cluster = new cvClusterMock();
  this.context = context;
  this.context.load('jsonmodules.js');
  this.context.load('clusterobject.js');
  this.cluster.find = function(what) {
    return this.objects[what];
  }
}

Configuration.prototype = {
  cluster : null,
  context : null,

  getCluster : function() {
    return this.cluster;
  },
  
  initClusterObjects : function() {
    for(var type in this.cluster.objects) {
      for(var j = 0; j < this.cluster.objects[type].length; j++) {
        this.cluster.objects[this.cluster.objects[type][j].object.uniqueKey] = this.cluster.objects[type][j];
      }
    }
  }
}

module.exports = Configuration;


