/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  var myDialog = dock.dialogs.list[index];
  current = myDialog.arguments.object;
  var error = myDialog.arguments.usedby;

  setDialogTitle('Usage of ' + current.resolveName())
  document.getElementById('message').setAttribute('value', 'Failed to remove ' + current.resolveName() + ' because of these dependecies:');
  tree = document.getElementById('tree');
  data = new Array();
  for(var i = 0; i < error.length; i++) {
    data.push(createTreeItem(error[i], i));
  }
  if(error.length == 0) {
    var one = new dock.cvWillChange();
    one.type = 'None';
    one.parameter = 'Internal error, contact your Cluster Manager reseller';
    data.push(createTreeItem(one, i));
  }
//   for(var i = error.length; i < 18; i++) data.push(blankTreeItem());
  loadTable();
}

function createTreeItem(one, i) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['type'] = one.changeBaseType;
  var name = '';
  if(one.key) {
    if(one.changeBaseType == 'MonConf') {
      name = current.cluster.getMonConfName(one.key);
    } else {
      name = current.cluster.find(one.key);
      if(name) name = name.resolveName();
    }
  }
  item['name'] = name;
  item['parameter'] = one.parameter;
  item['autochange'] = one.autoChange;
  return item;
}
