// pref("toolkit.defaultChromeURI", "chrome://cmgui/content/cmgui.xul");
pref("toolkit.defaultChromeURI", "chrome://cmgui/content/splash.xul");
pref("toolkit.defaultChromeFeatures", "centerscreen,chrome");

/* hidden window preferences (needed for Mac OS X) */
pref("browser.hiddenWindowChromeURL", "chrome://cmgui/content/hiddenWindow.xul");

/* debugging prefs */
pref("browser.dom.window.dump.enabled", false);
pref("javascript.options.showInConsole", false);
pref("javascript.options.strict", false);
pref("nglayout.debug.disable_xul_cache", true);
pref("nglayout.debug.disable_xul_fastload", false);

pref("intl.accept_charsets", "utf-8");

pref("xpinstall.dialog.confirm", "chrome://mozapps/content/xpinstall/xpinstallConfirm.xul");
pref("xpinstall.dialog.progress.skin", "chrome://mozapps/content/extensions/extensions.xul?type=themes");
pref("xpinstall.dialog.progress.chrome", "chrome://mozapps/content/extensions/extensions.xul?type=extensions");
pref("xpinstall.dialog.progress.type.skin", "Extension:Manager-themes");
pref("xpinstall.dialog.progress.type.chrome", "Extension:Manager-extensions");
pref("extensions.update.enabled", true);
pref("extensions.update.interval", 86400);
pref("extensions.dss.enabled", false);
pref("extensions.dss.switchPending", false);
pref("extensions.ignoreMTimeChanges", false);
pref("extensions.logging.enabled", true);
pref("general.skins.selectedSkin", "classic/1.0");

pref("extensions.blocklist.url", "");
pref("extensions.blocklist.enabled", false);
pref("extensions.getAddons.cache.enabled", false);

/* for browser colors, css doesn't work */
pref("browser.display.use_document_colors", false);
pref("browser.display.use_system_colors", false);
pref("browser.display.foreground_color", "#333333");
pref("browser.display.background_color", "#e8e8e8");

/* suppress popup on redirect, e.g., HTTP 307 */
pref("network.http.prompt-temp-redirect", false);

/* allow clipboard */
pref("capability.policy.policynames", "allowclipboard");
pref("capability.policy.allowclipboard.sites", "");
pref("capability.policy.allowclipboard.Clipboard.cutcopy", "allAccess");
pref("capability.policy.allowclipboard.Clipboard.paste", "allAccess");
