var dock;
var current;

function onLoad() {
  dock = getDock();
  println(".Load: " + document.title);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh sdk example");
}

function extension() {
  var thread = new dock.getThread(current);
  thread.call = function() {
      // NEVER do any printing / document access from inside a thread, this will sometimes crash in very obscure ways
      this.result = [this.current.services['cmmain'].extension('helloworld', '', ''), this.current.services['cmmain'].lastError()];
    }
  thread.callback = function() {
    // this code is executed on the main thread, so printing is allowed
    if(this.result[1] != 0) {
        dock.translateError(this.result[1], "Extension");
      } else {
        dock.displayError("Extension returned: " + this.result[0]);
      }
    }
  thread.background.dispatch(new dock.workingThread(thread), thread.background.DISPATCH_NORMAL);  
}
